<?php

namespace App\Http\Controllers\V1;


use App\Http\Controllers\Controller;
use App\Core\Service\PropertyRoomFactMappingService;
use App\Core\Service\PropertyFactService;


use Predis\Replication\RoleException;
use Illuminate\Http\Request;

use App;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\Config;
use Exception;
use App\Exceptions\ApiErrorException;

class PropertyRoomFactMappingController extends Controller
{


    private $request;
    private $propertyRoomFactMappingService;
    private $propertyFactService;


    public function __construct(
        Request $request,
        PropertyRoomFactMappingService $propertyRoomFactMappingService,
        PropertyFactService $propertyFactService
    )
    {
        $this->request = $request;
        $this->propertyRoomFactMappingService = $propertyRoomFactMappingService;
        $this->propertyFactService = $propertyFactService;

    }

    public function updatePropertyRoomFactMapping(Request $request)
    {
        $response = ['status' => false, 'message' => '', 'data' => null, 'statusCode' => 500];

        try
        {
            if (is_null($this->request->getContent())) {
                throw new ApiErrorException(lang('Parameter Error.'));
            }
            $params = json_decode($this->request->getContent(),1);
            $params = current($params);
            $params['user_id'] =  $this->request->auth->id;

            $response =  $this->propertyRoomFactMappingService->updatePropertyRoomFactMapping($params);

        }catch (ApiErrorException $e) {
            $response['message'] = implode(', ', $e->getMessageArr());
            $response['statusCode'] = 400;
        } catch (Exception $e) {
            $message = $e->getFile() . " " . $e->getLine() . " " . $e->getMessage();
            Log::error($message);
            $response['message'] = $e->getMessage();
            $response['statusCode'] = 500;
        }

        return apiResponse($response['status'], $response['message'], $response['data'], $response['statusCode']);
    }

    public function getPropertyRoomFact(Request $request)
    {

        $response = ['status' => false, 'message' => '', 'data' => null, 'statusCode' => 500];
        try {

            if (is_null($this->request->getContent())) {
                throw new ApiErrorException(lang('Parameter Error.'));
            }

            $params = $this->request->params;

            $requestFact = [
                'locale' => fillOnUndefined($params, 'locale'),
                'property_id' => fillOnUndefined($params, 'property_id'),
                'room_id' => fillOnUndefined($params, 'room_id'),
            ];

            $getPropertyFact = $this->propertyFactService->getPropertyRoomFact($requestFact);

            $response = ['status' => 1, 'statusCode' => 200, 'message' => null, 'data' => $getPropertyFact['data'] ];

        } catch (ApiErrorException $e) {
            $response['message'] = implode(', ', $e->getMessageArr());
            $response['statusCode'] = 400;
        } catch (Exception $e) {
            $message = $e->getFile() . " " . $e->getLine() . " " . $e->getMessage();
            Log::error($message);
            $response['message'] = $e->getMessage();
            $response['statusCode'] = 500;
        }
        return apiResponse($response['status'], $response['message'], $response['data'], $response['statusCode']);


    }

    public function updatePropertyRoomFactIsFeature(){

        $response = ['status' => false, 'message' => '', 'data' => null, 'statusCode' => 500];

        try
        {
            if (is_null($this->request->getContent())) {
                throw new ApiErrorException(lang('Parameter Error.'));
            }
            $params = json_decode($this->request->getContent(),1);
            $params = current($params);
            $params['user_id'] =  $this->request->auth->id;

            $response =  $this->propertyRoomFactMappingService->updatePropertyRoomFactIsFeature($params);

        }catch (ApiErrorException $e) {
            $response['message'] = implode(', ', $e->getMessageArr());
            $response['statusCode'] = 400;
        } catch (Exception $e) {
            $message = $e->getFile() . " " . $e->getLine() . " " . $e->getMessage();
            Log::error($message);
            $response['message'] = $e->getMessage();
            $response['statusCode'] = 500;
        }

        return apiResponse($response['status'], $response['message'], $response['data'], $response['statusCode']);

    }


}
